//
// Created by z00500078 on 2022/5/17.
//

#ifndef HUAWEICLOUD_CPP_SDK_SIS_CLION_RASRLISTENER_H
#define HUAWEICLOUD_CPP_SDK_SIS_CLION_RASRLISTENER_H

#include "iostream"
#include "string"
#include "IoUtil.h"


class RasrListener {
public:
    void OnConnect() {
        std::cout << "rasr Connect success" << std::endl;
    }

    void OnStart(std::string text) {
        std::cout << "rasr receive start response " << text << std::endl;
    }

    void OnResp(std::string text) {
        // text encoded by utf-8 contains chinese character, which will cause error code. So we should convert to ansi
        // std::cout << "rasr receive " << text << std::endl;
        std::cout << "rasr receive " << Utf8ToAnsi(text) << std::endl;
    }

    void OnEnd(std::string text) {
        std::cout << "rasr receive end response " << text << std::endl;
    }

    void OnClose() {
        std::cout << "rasr receive Close" << std::endl;
    }

    void OnError(std::string text) {
        std::cout << "rasr receive error" << text << std::endl;
    }

    void OnEvent(std::string text) {
        std::cout << "rasr receive event" << text << std::endl;
    }


};

#endif //HUAWEICLOUD_CPP_SDK_SIS_CLION_RASRLISTENER_H
