#pragma once

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <iostream>
#include <atlstr.h>
#include <json/value.h>



class RasrRequest {
private:
    std::string audioFormat;
    std::string audioProperty;
    std::string punc = "no";
    std::string digitNorm = "yes";
    int vadHead = 10000;
    int vadTail = 500;
    int maxSeconds = 30;
    std::string intermediateResult = "no";
    std::string vocabularyId = "";
    std::string needWordInfo = "no";

public:
    RasrRequest(std::string audio_format, std::string audio_property);

    void SetPunc(std::string punc);

    void SetDigitNorm(std::string digit_norm);

    void SetVadHead(int vad_head);

    void SetVadTail(int vad_tail);

    void SetMaxSeconds(int max_seconds);

    void SetIntermediateResult(std::string intermediate_result);

    void SetVocabularyId(std::string vocabulary_id);

    void SetNeedWordInfo(std::string need_word_info);

    std::string ConstructParams();

};
