#pragma once

#include <stdlib.h>
#include "signer.h"
#include <iostream>
#include <atlstr.h>

//using namespace std;

#include "WebsocketClient.h"
#include <fstream>
#include "string"
#include <vector>
#include "set"
#include "AuthInfo.h"
#include "RttsRequest.h"
#include "HttpConfig.h"
#include "map"
#include "RttsListener.h"


class RttsClient {

private:
    AuthInfo authInfo;
    WebsocketClient ws;
    HttpConfig httpConfig;
    WebsocketService::ptr websocketServicePtr;

    void Connect();
	void SendRequest(RttsRequest request);
    void WaitStatus(std::set<WebsocketStatus> targetStatuses, int maxWaitTime);
	void Close();
	bool CheckConnect();
	bool CheckSend();
public:
    RttsClient(AuthInfo authinfo, WebsocketService::ptr servicePtr, HttpConfig config) {
        authInfo = authinfo;
        httpConfig = config;
        websocketServicePtr = servicePtr;
        ws.setWebsocketServicePtr(websocketServicePtr);
		websocketServicePtr->SetListenerType("rtts");
    }

    ~RttsClient(void) {};

    void Synthesis(RttsRequest request);


};

