//
// Created by z00500078 on 2022/5/17.
//

#ifndef HUAWEICLOUD_CPP_SDK_SIS_CLION_RttsListener_H
#define HUAWEICLOUD_CPP_SDK_SIS_CLION_RttsListener_H

#include "iostream"
#include "string"
#include "fstream"
#include "vector"


class RttsListener {

public:
    void OnConnect() {
        std::cout << "rtts Connect success" << std::endl;
    }

    void OnStart(std::string text) {
        std::cout << "rtts receive start response " << text << std::endl;
    }

    void OnResp(std::string binaryData) {
		if (isSaved) {
			dataContents.push_back(binaryData);
		}
    }

    void OnEnd(std::string text) {
        std::cout << "rtts receive end response " << text << std::endl;
		if (isSaved) {
			std::ofstream fout(filePath,  std::ios::binary);
			if (!fout.is_open()) {
				std::cout << "filePath " << filePath << " is invalid";
				return;
			}
			for (int i = 0; i < dataContents.size(); i++) {
				fout.write(dataContents[i].data(), dataContents[i].size());
			}
			fout.close();
			std::cout << "success to save file in " << filePath << std::endl;
		}

    }

    void OnClose() {
        std::cout << "rtts receive Close" << std::endl;
    }

    void OnError(std::string text) {
        std::cout << "rtts receive error" << text << std::endl;
    }

	void SetFilePath(std::string fPath) {
		filePath = fPath;
	}

	void SetSaved(bool saved) {
		isSaved = saved;
	}

private:
	std::string filePath;
	bool isSaved = false;
	std::vector<std::string> dataContents;

};

#endif //HUAWEICLOUD_CPP_SDK_SIS_CLION_RttsListener_H
