#pragma   once
#ifndef WEBSOCKET_CLIENT_H
#define WEBSOCKET_CLIENT_H


//#include <websocketpp/config/asio_no_tls_client.hpp>
//#include <websocketpp/client.hpp>


#include "websocketpp/config/asio_client.hpp"
#include "websocketpp/client.hpp"

#include "websocketpp/common/thread.hpp"

#include "websocketpp/common/memory.hpp"


#include <string>
#include <locale>
#include <codecvt>
#include <vector>
#include "signer.h"
#include "map"
#include "WebsocketService.h"
#include "IoUtil.h"

using websocketpp::lib::bind;

typedef websocketpp::client<websocketpp::config::asio_tls_client> client;
typedef websocketpp::lib::shared_ptr<websocketpp::lib::asio::ssl::context> context_ptr;

typedef websocketpp::config::asio_client::message_type::ptr message_ptr;

class WebsocketClient {

public:
    WebsocketService::ptr getWebsocketServicePtr() {
        return websocketServicePtr;
    }

    void setWebsocketServicePtr(WebsocketService::ptr websocketService) {
        websocketServicePtr = websocketService;
    }

    WebsocketClient();
    ~WebsocketClient();

    bool Connect(std::string const &url, std::map<std::string, std::string> headers);

    bool Close(std::string reason = "");

    bool SendTxt(std::string message);

    bool SendBinary(unsigned char *buff, size_t size);

private:
    WebsocketService::ptr websocketServicePtr;
    websocketpp::connection_hdl hdl;
    client mClient;
    websocketpp::lib::shared_ptr<websocketpp::lib::thread> mThread;
};


#endif
