@echo off

set winRar="C:\Program Files\WinRAR\WinRAR.exe"


set project_folder=%~dp0..\
set base_folder=%project_folder%build
set build_folder=%base_folder%\build_win64
set install_folder=%base_folder%\install\SisCppSdk.X_win64

set sdk_folder=%build_folder%\SisCppSdk
set thirdparty_folder=%build_folder%\thirdparty

set openssl_folder=%thirdparty_folder%\openssl-prefix
set openssl_include_folder=%openssl_folder%\include

set jsoncpp_folder=%thirdparty_folder%\jsoncpp-prefix
set jsoncpp_include_folder=%jsoncpp_folder%\include

set boost_folder=%thirdparty_folder%\boost-prefix
set boost_include_folder=%boost_folder%\include

set websocketpp_folder=%thirdparty_folder%\websocketpp-prefix
set websocketpp_include_folder=%websocketpp_folder%\include

::initBuildDirectory
	echo Prepare the build directory.

	echo base_folder: %base_folder%
	if exist %base_folder% (
		echo %base_folder% is exist
	) else (
		echo %base_folder% is not exist
		md %base_folder%
	)

	echo build_folder: %build_folder%
	if exist %build_folder% (
		echo %build_folder% is exist
	) else (
		echo %build_folder% is not exist
		md %build_folder%
	)

	echo install_folder: %install_folder%
	if exist %install_folder% (
		echo %install_folder% is exist
	) else (
		echo %install_folder% is not exist
		md %install_folder%
	)
	
	echo sdk_folder: %sdk_folder%
	if exist %sdk_folder% (
		echo %sdk_folder% is exist
	) else (
		echo %sdk_folder% is not exist
		md %sdk_folder%
	)
	
	echo thirdparty_folder: %thirdparty_folder%
	if exist %thirdparty_folder% (
		echo %thirdparty_folder% is exist
	) else (
		echo %thirdparty_folder% is not exist
		md %thirdparty_folder%
	)

::goto:eof


call %vc64Dir%\vcvars64.bat


::buildJsoncpp
	echo Begin build JsonCpp.
	
	if exist %jsoncpp_folder% (
		echo %jsoncpp_folder% is exist
	) else (
		echo %jsoncpp_folder% is not exist
		md %jsoncpp_folder%
		md %jsoncpp_include_folder%
	)
	
	echo cd %jsoncpp_folder%
	cd %jsoncpp_folder%
	
	echo unzip %project_folder%thirdparty\jsoncpp-1.9.4.zip to %jsoncpp_folder%
	%winRar% x -ad -y "%project_folder%thirdparty\jsoncpp-1.9.4.zip"

	set jsoncpp_src_folder=%jsoncpp_folder%\jsoncpp-1.9.4\jsoncpp-master
	xcopy %jsoncpp_src_folder%\include %jsoncpp_include_folder% /y/s

::goto:eof


::buildOpenssl
	echo Begin build openssl-1.1.1l

	if exist %openssl_folder% (
		echo %openssl_folder% is exist
	) else (
		echo %openssl_folder% is not exist
		md %openssl_folder%
		md %openssl_include_folder%
	)

	echo cd %openssl_folder%
	cd %openssl_folder%
	
	echo unzip %project_folder%thirdparty\openssl-1.1.1l.tar.gz to %openssl_folder%
 	%winRar% x -ad -y "%project_folder%thirdparty\openssl-1.1.1l.tar.gz"

	set openssl_src_folder=%openssl_folder%\openssl-1.1.1l\openssl-1.1.1l
	xcopy %openssl_src_folder%\include %openssl_include_folder% /y/s
	copy /y %project_folder%\thirdparty\openssl_win_prj\opensslconf.h %openssl_include_folder%\openssl
	
::goto:eof


::buildboost
	echo Begin build boost.

	if exist %boost_folder% (
		echo %boost_folder% is exist
	) else (
		echo %boost_folder% is not exist
		md %boost_folder%
		md %boost_include_folder%
		md %boost_include_folder%
	)
	
	echo cd %boost_folder%
	cd %boost_folder%
	
	echo unzip %project_folder%thirdparty\boost_1_77_0.zip to %boost_folder%
	%winRar% x -ad -y "%project_folder%thirdparty\boost_1_77_0.zip"

	set boost_src_folder=%boost_folder%\boost_1_77_0
	xcopy %boost_src_folder%\include %boost_include_folder% /y/s

::goto:eof


::buildwebsocketpp
	echo Begin build websocketpp.
	
	if exist %websocketpp_folder% (
		echo %websocketpp_folder% is exist
	) else (
		echo %websocketpp_folder% is not exist
		md %websocketpp_folder%
		md %websocketpp_include_folder%
	)
	
	echo cd %websocketpp_folder%
	cd %websocketpp_folder%
	
	echo unzip %project_folder%thirdparty\websocketpp-master.zip to %websocketpp_folder%
	%winRar% x -ad -y "%project_folder%thirdparty\websocketpp-master.zip"

	set websocketpp_src_folder=%websocketpp_folder%\websocketpp-master\websocketpp-master
	xcopy %websocketpp_src_folder%\include %websocketpp_include_folder% /y/s

::goto:eof
