//
// Created by z00500078 on 2022/5/17.
//
#include "IoUtil.h"
#include "WebsocketStatus.h"

unsigned char* ReadBinary(std::string filePath, int* fileLength) {

	std::ifstream fin(filePath, std::ios::binary);
	if (!fin.is_open()) {
		std::cout << filePath << " is empty" << std::endl;
		return nullptr;
	}
	fin.seekg(0, std::ios::end);
	int length = fin.tellg();
	fin.seekg(0, std::ios::beg);
	char* results = new char[length];
	fin.read(results, length);
	*fileLength = length;
	fin.close();
	return (unsigned char*)results;
}
std::wstring StringToWstring(const std::string &s) {
	using default_convert = std::codecvt<wchar_t, char, std::mbstate_t>;
	std::wstring_convert<default_convert> conv(new default_convert("CHS"));
	return conv.from_bytes(s);
}

std::string WstringToString(const std::wstring &s) {
	using default_convert = std::codecvt<wchar_t, char, std::mbstate_t>;
	std::wstring_convert<default_convert> conv(new default_convert("CHS"));
	return conv.to_bytes(s);
}

std::string AnsiToUtf8(const std::string &s) {
	std::wstring_convert<std::codecvt_utf8<wchar_t> > conv;
	return conv.to_bytes(StringToWstring(s));
}

std::string Utf8ToAnsi(const std::string &s) {
	std::wstring_convert<std::codecvt_utf8<wchar_t> > conv;
	return WstringToString(conv.from_bytes(s));
}

std::string WebsocketStatusToStr(WebsocketStatus status) {
	switch (status) {
	case WB_PRE_START: return "PRE_START";
	case WB_START: return "START";
	case WB_END: return "END";
	case WB_BLOCKING: return "BLOCKING";
	case WB_CONNECT: return "CONNECT";
	case WB_CLOSE: return "CLOSE";
	case WB_ERROR: return "ERROR";
	default: return "UNKNOWN_STATUS";
	}
}

std::string GetEnv(std::string envName) {
	std::string dst;
	char* buf = nullptr;
	size_t sz = 0;
	if (_dupenv_s(&buf, &sz, envName.c_str()) == 0 && buf != nullptr) {
		dst = buf;
	}
	free(buf);
	return dst;
}
