#pragma once


#include "RasrRequest.h"

RasrRequest::RasrRequest(std::string audio_format, std::string audio_property) {
	RasrRequest::audioFormat = audio_format;
	RasrRequest::audioProperty = audio_property;
};

void RasrRequest::SetPunc(std::string punc) {
	RasrRequest::punc = punc;
};
void RasrRequest::SetDigitNorm(std::string digit_norm) {
	RasrRequest::digitNorm = digit_norm;
};

void RasrRequest::SetVadHead(int vad_head) {
	RasrRequest::vadHead = vad_head;
};
void RasrRequest::SetVadTail(int vad_tail) {
	RasrRequest::vadTail = vad_tail;
};
void RasrRequest::SetMaxSeconds(int max_seconds) {
	RasrRequest::maxSeconds = max_seconds;
};
void RasrRequest::SetIntermediateResult(std::string intermediate_result) {
	RasrRequest::intermediateResult = intermediate_result;
};

void RasrRequest::SetVocabularyId(std::string vocabulary_id) {
	RasrRequest::vocabularyId = vocabulary_id;
};
void RasrRequest::SetNeedWordInfo(std::string need_word_info) {
	RasrRequest::needWordInfo = need_word_info;
};

std::string RasrRequest::ConstructParams() {
	Json::Value root;
	Json::Value config;
	config["property"] = audioProperty;
	config["audio_format"] = audioFormat;
	config["add_punc"] = punc;
	config["digit_norm"] = digitNorm;
	config["vad_head"] = vadHead;
	config["vad_tail"] = vadTail;
	config["max_seconds"] = maxSeconds;
	config["interim_results"] = intermediateResult;
	config["need_word_info"] = needWordInfo;
	if (!vocabularyId.empty()) {
		config["vocabulary_id"] = vocabularyId;
	}
	root["config"] = config;
	root["command"] = "START";
	return root.toStyledString();
}