#pragma once


#include "RttsRequest.h"

RttsRequest::RttsRequest(std::string text) {
	RttsRequest::text = text;
};

void RttsRequest::SetAudioFormat(std::string audioFormat) {
	RttsRequest::audioFormat = audioFormat;
};
void RttsRequest::SetAudioProperty(std::string audioProperty) {
	RttsRequest::audioProperty = audioProperty;
};

void RttsRequest::SetSampleRate(std::string sampleRate) {
	RttsRequest::sampleRate = sampleRate;
};
void RttsRequest::SetPitch(int pitch) {
	RttsRequest::pitch = pitch;
};
void RttsRequest::SetVolume(int volume) {
	RttsRequest::volume = volume;
};
void RttsRequest::SetSpeed(int speed) {
	RttsRequest::speed = speed;
};


std::string RttsRequest::ConstructParams() {
	Json::Value root;
	Json::Value config;

	config["audio_format"] = audioFormat;
	if (!audioProperty.empty()) {
		config["property"] = audioProperty;
	}
	config["sample_rate"] = sampleRate;
	config["speed"] = speed;
	config["pitch"] = pitch;
	config["volume"] = volume;
	root["text"] = text;
	root["config"] = config;
	root["command"] = "START";
	return root.toStyledString();
}