#include <iostream>

#include "IoUtil.h"
#include "RttsClient.h"
#include "RttsRequest.h"



void OnRttsConnect() {
	std::cout << "now rtts client Connect success" << std::endl;
}

void OnRttsStart(std::string text) {
	std::cout << "now rtts client receive start response: " << text << std::endl;
}

void OnRttsEnd(std::string text) {
	std::cout << "now rtts client  receive end response: " << text << std::endl;
}


void OnRttsClose() {
	std::cout << "now rtts client receive Close" << std::endl;
}

void OnRttsError(std::string text) {
	std::cout << "now  rtts client receive error: " << text << std::endl;
}


void OnRttsBinary(std::string binaryData) {
	// data content can be avaliable by data() method, data length can be avaliable by size() method
	// const char* data = binaryData.data();
	// int dataLength = binaryData.size();
	std::cout << "now rtts client receive binary data " << binaryData.size() << std::endl;
}

void RttsTest() {
	// 1. config parameter
	// 1.1 init authInfo
	// ֤õakskӲ뵽лĴ洢кܴİȫգļ߻Ĵţʹʱܣȷȫ
    // ʾakskڻʵ֤ΪбʾǰڱػûHUAWEICLOUD_SDK_AKHUAWEICLOUD_SDK_SK
	std::string ak = GetEnv("HUAWEICLOUD_SDK_AK");
	std::string sk = GetEnv("HUAWEICLOUD_SDK_SK");
	std::string region = "";
	std::string projectId = "";
	AuthInfo authInfo(ak, sk, region, projectId);

	// 1.2 config Connect parameter
	HttpConfig httpConfig;
	httpConfig.SetReadTimeout(20000);
	httpConfig.SetConnectTimeout(20000);

	// 1.3 config callback, callback function are optional, if not set, it will use function in RttsListner
	WebsocketService::ptr websocketServicePtr = websocketpp::lib::make_shared<WebsocketService>();
	websocketServicePtr->SetOnConnectFunc(OnRttsConnect);       // Connect success callback
	websocketServicePtr->SetOnStartFunc(OnRttsStart);				// receive start response callback
	websocketServicePtr->SetOnEndFunc(OnRttsEnd);               // receive end response callback
	websocketServicePtr->SetOnCloseFunc(OnRttsClose);           // Close callback
	websocketServicePtr->SetOnErrorFunc(OnRttsError);           // receive error callback
	websocketServicePtr->SetOnBinaryFunc(OnRttsBinary);     // receive binary callback

	// 1.3 option, use RttsListener, which can save file; You can edit RttsListener.h to finish your own business
	//WebsocketService::ptr websocketServicePtr = websocketpp::lib::make_shared<WebsocketService>();
	//RttsListener rttsListener;
	//rttsListener.SetSaved(true);
	//rttsListener.SetFilePath("d:/test.pcm");
	//websocketServicePtr->SetRttsListener(rttsListener);


	// 1.4 config request parameter
	std::string text = AnsiToUtf8("Ϊڰÿÿͥÿ֯ﻥ硣");
	RttsRequest request(text);
	request.SetAudioFormat("pcm");
	request.SetVolume(50);
	request.SetSpeed(0);
	request.SetPitch(0);
	request.SetSampleRate("8000");
	request.SetAudioProperty("chinese_xiaoyan_common");


	// 2. init client
	RttsClient* rttsClient = new RttsClient(authInfo, websocketServicePtr, httpConfig);

	// 3. send request
	rttsClient->Synthesis(request);
	// wait for save file, if setSaved false in rttsListener or don't use rttsListener, it can be removed.
	std::this_thread::sleep_for(std::chrono::milliseconds(2000));
	delete rttsClient;

}
